<template>
    <div class="canvas-dashboard__item">
        <h2>
            <span><slot name="icon"></slot></span>
            <slot name="title"></slot>
        </h2>

        <form>
            <textarea
                class="canvas-dashboard__textarea"
                @input="onInput"
                @keyup="onSave()"
                ref="messageBox"
                placeholder="Ingresa una nueva idea ..."
                v-model="itemValue"
            >
            </textarea>
            <template v-if="written">
                <p v-if="saving">
                    <img src="/images/canvas/update.svg" alt="" />
                    Guardando ...
                </p>
                <p v-else>
                    <img src="/images/canvas/checked.svg" alt="" />
                    Guardado
                </p>
            </template>
        </form>
    </div>
</template>

<script>
import canvas from "@/services/Canvas.js";

const debounce = (callback, wait) => {
    let timerId;
    return (...args) => {
        clearTimeout(timerId);
        timerId = setTimeout(() => {
            callback(...args);
        }, wait);
    };
};

export default {
    name: "canvas-item",
    props: {
        field: {
            type: String,
        },
        value: {
            type: String,
        },
    },
    data() {
        return {
            itemValue: this.value,
            written: false,
            saving: false,
        };
    },
    created() {
        this.onSave = debounce(async () => {
            let data = {
                field: this.field,
                value: this.itemValue,
            };

            await canvas.update(data);
            this.saving = false;
        }, 500);
    },
    mounted() {
        this.setTextareaHeight();
    },
    methods: {
        onInput() {
            this.written = true;
            this.saving = true;
            this.setTextareaHeight();
        },
        setTextareaHeight() {
            let messageBox = this.$refs.messageBox;
            let scrollHeight = messageBox.scrollHeight;
            if (messageBox.value) {
                messageBox.style.height = scrollHeight + "px";
            } else {
                messageBox.style.height = "auto";
            }
        },
    },
};
</script>

<style lang="scss" scoped></style>
